/*
+--------+
|Divergence Trader
+--------+
*/


// variables declared here are GLOBAL in scope

#property copyright "Ron Thompson"
#property link      "http://www.lightpatch.com/forex"

// user input
extern double MaximumRisk=20;
extern double proximity=7;
extern double Lots=0.01;              // how many lots to trade at a time 
extern int    Fast_Period=7;
extern int    Slow_Period=88;
extern double DVBuySell=0.0005;//0.0011
extern double DVStayOut=0.0073;
extern double ProfitMade=20;          // how much money do you expect to make
extern double LossLimit=115;          // how much loss can you tolorate
extern double TrailStop=20;         // trailing stop (999=no trailing stop)
extern int    PLBreakEven=9999;       // set break even when this many pips are made (999=off)
extern int    BasketProfit=  1;      // if equity reaches this level, close trades
extern double TakeProfit = 8;
extern int    BasketLoss=9999;        // if equity reaches this negative level, close trades
extern string Dynamic_Trailing_Stop_Settings = "Dynamic Trailing Stop Settings";
extern bool               EnableTrailingStop = true; // Enable Dynamic Trailing Stop
extern int                    TrailATRPeriod = 7;
extern double             TrailingStopFactor = 1.45;
// Dynamic Trailing stop (TS) global variables
double PrevBuyStop=0,BuyStop=0;
double PrevSellStop=0,SellStop=0,TrailingStop=0;

// externals that don't need to be external
       int    Slippage=0;             // how many pips of slippage can you tolorate
       bool   FileData=false;         // write to file exery tick?

// naming and numbering
int      MagicNumber  = 200601182020; // allows multiple experts to trade on same account
string   TradeComment = "Divergence_07_";

// Bar handling
datetime bartime=0;                   // used to determine when a bar has moved
int      bartick=0;                   // number of times bars have moved
int      objtick=0;                   // used to draw objects on the chart
int      tickcount=0;

// Trade control
bool TradeAllowed=true;               // used to manage trades
double EntryCondition=0; // 0=standing by, 1=buy, 2=sell

// Min/Max tracking
double maxOrders;
double maxEquity;
double minEquity;



//+-------------+
//| Custom init |
//|-------------+
// Called ONCE when EA is added to chart or recompiled

int init()
  {
   int    i;
   string o;
   
   //remove the old objects 
   for(i=0; i<Bars; i++) 
     {
      o=DoubleToStr(i,0);
      ObjectDelete("myx"+o);
      ObjectDelete("myz"+o);
     }
   objtick=0;

   ObjectDelete("Cmmt");
   ObjectCreate( "Cmmt", OBJ_TEXT, 0, Time[20], High[20]+(5*Point) );
   ObjectSetText("Cmmt","Divergence=X.XXXX",10,"Arial",White);

   Print("Init happened ",CurTime());
   Comment(" ");
  }

//+----------------+
//| Custom DE-init |
//+----------------+
// Called ONCE when EA is removed from chart

int deinit()
  {
   int    i;
   string o;
   //remove the old objects 
   
   for(i=0; i<Bars; i++) 
     {
      o=DoubleToStr(i,0);
      ObjectDelete("myx"+o);
      ObjectDelete("myz"+o);
     }
   objtick=0;
   
   Print("MAX number of orders ",maxOrders);
   Print("MAX equity           ",maxEquity);
   Print("MIN equity           ",minEquity);
      
   Print("DE-Init happened ",CurTime());
   Comment(" ");
  }


//+-----------+
//| Main      |
//+-----------+
// Called EACH TICK and each Bar[]

int start()
  {
  
  
  // order tracking
   
   double p=Point;
   double spread=Ask-Bid;
   double spread2=(Ask-Bid)+2*Point; // for setting unattended stoploss and takeprofit
   
   int      cnt=0;
   int      gle=0;
   int      OrdersPerSymbol=0;
   
   int      iFileHandle;
  
   // stoploss and takeprofit and close control
   double SL=0;
   double TP=0;
   double CurrentProfit=0;
   double CurrentBasket=0;
   
   // direction control
   bool BUYme=false;
   bool SELLme=false;
   
   
   // Trade stuff
   double diverge;
   double maF1,maF2,maS1;

   // bar counting
   if(bartime!=Time[0]) 
     {
      bartime=Time[0];
      bartick++; 
      objtick++;
      TradeAllowed=true;
     }

   OrdersPerSymbol=0;
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         OrdersPerSymbol++;
        }
     }
   if(OrdersPerSymbol>maxOrders) maxOrders=OrdersPerSymbol;


   //+-----------------------------+
   //| Insert your indicator here  |
   //| And set either BUYme or     |
   //| SELLme true to place orders |
   //+-----------------------------+

   int    Fast_Price = PRICE_OPEN;
   int    Fast_Mode  = MODE_EMA;
   maF1=iMA(Symbol(),0,Fast_Period,0,Fast_Mode,Fast_Price,0);
   maF2=iMA(Symbol(),0,Fast_Period,0,Fast_Mode,Fast_Price,1);//aaragorn added
   int    Slow_Price = PRICE_OPEN;
   int    Slow_Mode  = MODE_SMMA;
   maS1=iMA(Symbol(),0,Slow_Period,0,Slow_Mode,Slow_Price,0);
   


   diverge=(maF1-maS1);
   
   ObjectDelete("Cmmt");
   ObjectCreate("Cmmt", OBJ_TEXT, 0, Time[20], High[20]+(10*p));
   ObjectSetText("Cmmt","Divergence="+DoubleToStr(diverge,4),10,"Arial",White);
   if( diverge>= DVBuySell       && diverge<= DVStayOut       ) BUYme=true;
   if( diverge<=(DVBuySell*(-1)) && diverge>=(DVStayOut*(-1)) ) SELLme=true;
   
   if(FileData)
     {
      tickcount++;
      iFileHandle = FileOpen("eaDivergence07", FILE_CSV|FILE_READ|FILE_WRITE, ",");
      FileSeek(iFileHandle, 0, SEEK_END);
      FileWrite(iFileHandle, bartick, " ", tickcount, " ", diverge);
      FileFlush(iFileHandle);
      FileClose(iFileHandle);
     }

   //+------------+
   //| End Insert |
   //+------------+
   double HH=0,LL=0,HH_LLAvePeriod=1,ATR=0,ATAPeriod=2;
   HH = High[Highest(NULL,0,MODE_HIGH,HH_LLAvePeriod,0)];    
   LL = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriod,0)];
   ATR= iATR(NULL,0,ATAPeriod,0);
   //ENTRY LONG (buy, Ask) 
   if(TradeAllowed && BUYme)
      {
       //Ask(buy, long)
       
       if(maF2<maF1) LossLimit=0;//aaragorn added
      if(LossLimit ==0) SL=0; else SL=Ask-( (LossLimit +7)*Point );
      if(ProfitMade==0) TP=0; else TP=Ask+( (ProfitMade+7)*Point );
      //TP=Ask+TakeProfit*Point;
      TP=Ask+NormalizeDouble( ((ATR)/1.5),Digits);
      if(Ask>LL+(proximity*Point))
      {
      return(0);
      }
     /*if(maF2>maF1)
      {
      return(0);
      //SL=Ask-( (7)*Point );
      }*/
      int tkt=0;
      Lots=LotSize();
      tkt=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,TradeComment,MagicNumber,White);
      EntryCondition=1; // 0=standingby, 1=buy, 2=sell
      
 /*     int FileHandle = 0;
      FileHandle = FileOpen("divergenceEA.txt",FILE_READ|FILE_WRITE);
      FileSeek(FileHandle, 0, SEEK_END);
      FileWrite(FileHandle, "L OrderTicket: ",tkt," bartick: ",bartick, " tickcount: ", tickcount, " diverge: ", diverge," Acct. Equity: ",AccountEquity() );
      FileFlush(FileHandle);
      FileClose(FileHandle);
  */  
      /*if(Ask<maS1)
      {
      EntryCondition=1.1; // 0=standingby, 1=buy, , 1.1bought below ma 2=sell
      }*/
      gle=GetLastError();
      if(gle==0)
        {
         Print("BUY  Ask=",Ask," bartick=",bartick);
         ObjectCreate("myx"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], High[0]+(5*p));
         ObjectSetText("myx"+DoubleToStr(objtick,0),"B",15,"Arial",Red);
         bartick=0;
         TradeAllowed=false;
        }
         else 
        {
         Print("-----ERROR----- BUY  Ask=",Ask," error=",gle," bartick=",bartick);
        }
     }
        
   //ENTRY SHORT (sell, Bid)
   if(TradeAllowed && SELLme)
     {
      //Bid (sell, short)
      if(LossLimit ==0) SL=0; else SL=Bid+((LossLimit+7)*Point );
      if(ProfitMade==0) TP=0; else TP=Bid-((ProfitMade+7)*Point );
      TP=Bid-TakeProfit*Point;
      if(Bid<HH-(proximity*Point))
      {
      return(0);
      }
      int tkt1=0;
      Lots=LotSize();
      tkt1=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,TradeComment,MagicNumber,Red);
      EntryCondition=2; // 0=standingby, 1=buy, 2=sell
  /*    
      int FileHandle1 = 0;
      FileHandle1 = FileOpen("divergenceEA.txt",FILE_READ|FILE_WRITE);
      FileSeek(FileHandle1, 0, SEEK_END);
      FileWrite(FileHandle1, "S OrderTicket: ",tkt1," bartick: ",bartick, " tickcount: ", tickcount, " diverge: ", diverge," Acct. Equity: ",AccountEquity() );
      FileFlush(FileHandle1);
      FileClose(FileHandle1);
    */  
      /*if(Bid>maS1)
      {
      EntryCondition=2.1; // 0=standingby, 1=buy, , 1.1bought below ma, 2=sell, 2.1 sold above ma
      }*/
      gle=GetLastError();
      if(gle==0)
        {
         Print("SELL Bid=",Bid," bartick=",bartick); 
         ObjectCreate("myx"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], High[0]+(5*p));
         ObjectSetText("myx"+DoubleToStr(objtick,0),"S",15,"Arial",Red);
         bartick=0;
         TradeAllowed=false;
        }
         else 
        {
         Print("-----ERROR----- SELL Bid=",Bid," error=",gle," bartick=",bartick);
        }
     }

    DynamicTrailStop(); 
   //Basket profit or loss
   CurrentBasket=AccountEquity()-AccountBalance();
   
   if(CurrentBasket>maxEquity) maxEquity=CurrentBasket;
   if(CurrentBasket<minEquity) minEquity=CurrentBasket;
    // actual basket closure
   /*if( CurrentBasket>=BasketProfit || CurrentBasket<=(BasketLoss*(-1)) )
     {
      CloseEverything();
      EntryCondition=0; // 0=standingby, 1=buy, 2=sell
     }*/
 
 
 //--------------------------Drama---------------------Exits----------------
   

   /* 
    double maS1B=0,maF1B=0; 
    maS1B=iMA(Symbol(),0,Slow_Period,0,Slow_Mode,Slow_Price,2);
    maF1B=iMA(Symbol(),0,Fast_Period,0,Fast_Mode,Fast_Price,2);
     Print("EC: ",EntryCondition,"  &&  ",Ask+(5*Point)," Ask+(5*Point)>maS1 ",maS1);
    */ 
    double LL1=0;
    LL1 = Low[Lowest(NULL,0,MODE_LOW,HH_LLAvePeriod,1)];
    if( EntryCondition==1 && Bid<LL1-NormalizeDouble((((proximity)*2)*Point),Digits)    )
     {
     Print("CLOSING LONGS TRIGGERED");
      CloseEverything();
      
     }
   /*  if( EntryCondition==2 && Ask+(1*Point)>maS1)
     {
     Print("CLOSING SHORTS TRIGGERED");
      CloseEverything();
      EntryCondition=0; // 0=standingby, 1=buy, 2=sell
     }
     */
   //--------------------------------------------------------------------  
 
   // CLOSE order if profit target made
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
        {
        
         if(OrderType()==OP_BUY)
           {
            CurrentProfit=Bid-OrderOpenPrice() ;

            // modify for break even
            if (CurrentProfit >= PLBreakEven*p && OrderOpenPrice()>OrderStopLoss())
              {
               SL=OrderOpenPrice()+(spread*2);
               TP=OrderTakeProfit();
               OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP, White);
               gle=GetLastError();
               if(gle==0)
                 {
                  Print("MODIFY BREAKEVEN BUY  Bid=",Bid," bartick=",bartick); 
                  ObjectCreate("myz"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]-(7*p));
                  ObjectSetText("myz"+DoubleToStr(objtick,0),"BE",15,"Arial",White);
                 }
                  else 
                 {
                  Print("-----ERROR----- MODIFY BREAKEVEN BUY  Bid=",Bid," error=",gle," bartick=",bartick);
                 }
              }

            // modify for trailing stop
            if(CurrentProfit >= TrailStop*p )
              {
               SL=Bid-(TrailStop*p);
               TP=OrderTakeProfit();
               OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP, White);
               gle=GetLastError();
               if(gle==0)
                 {
                  Print ("MODIFY TRAILSTOP BUY  StopLoss=",SL,"  bartick=",bartick,"OrderTicket=",OrderTicket()," CurrProfit=",CurrentProfit); 
                  ObjectCreate("myz"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]-(7*p));
                  ObjectSetText("myz"+DoubleToStr(objtick,0),"TS",15,"Arial",White);
                 }
                  else 
                 {
                  Print("-----ERROR----- MODIFY TRAILSTOP BUY  Bid=",Bid," error=",gle," bartick=",bartick);
                 }
              }

            // did we make our desired BUY profit
            // or did we hit the BUY LossLimit
            if((ProfitMade>0 && CurrentProfit>=(ProfitMade*p)) || (LossLimit>0 && CurrentProfit<=((LossLimit*(-1))*p))  )
              {
               OrderClose(OrderTicket(),Lots,Bid,Slippage,White);
               gle=GetLastError();
               if(gle==0)
                 {
                  Print("CLOSE BUY  Bid=",Bid," bartick=",bartick); 
                  ObjectCreate("myz"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]-(7*p));
                  ObjectSetText("myz"+DoubleToStr(objtick,0),"C",15,"Arial",White);
                 }
                  else 
                 {
                  Print("-----ERROR----- CLOSE BUY  Bid=",Bid," error=",gle," bartick=",bartick);
                 }
              }
              
           } // if BUY


         if(OrderType()==OP_SELL)
           {

            CurrentProfit=OrderOpenPrice()-Ask;
            
            // modify for break even
            if (CurrentProfit >= PLBreakEven*p && OrderOpenPrice()<OrderStopLoss())
              {
               SL=OrderOpenPrice()-(spread*2);
               TP=OrderTakeProfit();
               OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP, Red);
               gle=GetLastError();
               if(gle==0)
                 {
                  Print("MODIFY BREAKEVEN SELL Ask=",Ask," bartick=",bartick);
                  ObjectCreate("myz"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]-(7*p));
                  ObjectSetText("myz"+DoubleToStr(objtick,0),"BE",15,"Arial",Red);
                 }
                  else 
                 {
                  Print("-----ERROR----- MODIFY BREAKEVEN SELL Ask=",Ask," error=",gle," bartick=",bartick);
                 }
              }

            // modify for trailing stop
            if(CurrentProfit >= TrailStop*p)
              {
               SL=Ask+(TrailStop*p);
               TP=OrderTakeProfit();
               OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP, Red);
               gle=GetLastError();
               if(gle==0)
                 {
                  Print ("MODIFY TRAILSTOP SELL StopLoss=",SL,"  bartick=",bartick,"OrderTicket=",OrderTicket()," CurrProfit=",CurrentProfit); 
                  ObjectCreate("myz"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]-(7*p));
                  ObjectSetText("myz"+DoubleToStr(objtick,0),"TS",15,"Arial",Red);
                 }
                  else 
                 {
                  Print("-----ERROR----- MODIFY TRAILSTOP SELL Ask=",Ask," error=",gle," bartick=",bartick);
                 }
              }

            // did we make our desired SELL profit?
            if( (ProfitMade>0 && CurrentProfit>=(ProfitMade*p)) || (LossLimit>0 && CurrentProfit<=((LossLimit*(-1))*p))  )
              {
               OrderClose(OrderTicket(),Lots,Ask,Slippage,Red);
               gle=GetLastError();
               if(gle==0)
                 {
                  Print("CLOSE SELL Ask=",Ask," bartick=",bartick);
                  ObjectCreate("myz"+DoubleToStr(objtick,0), OBJ_TEXT, 0, Time[0], Low[0]-(7*p));
                  ObjectSetText("myz"+DoubleToStr(objtick,0),"C",15,"Arial",Red);
                 }
                  else 
                 {
                  Print("-----ERROR----- CLOSE SELL Ask=",Ask," error=",gle," bartick=",bartick);
                 }
                 
              }

           } //if SELL
           
        } // if(OrderSymbol)
        
     } // for

  } // start()



//+-----------------+
//| CloseEverything |
//+-----------------+
// Closes all OPEN and PENDING orders

int CloseEverything()
  {
   double myAsk;
   double myBid;
   int    myTkt;
   double myLot;
   int    myTyp;

   int i;
   bool result = false;
    
   for(i=OrdersTotal();i>=0;i--)
     {
      OrderSelect(i, SELECT_BY_POS);

      myAsk=MarketInfo(OrderSymbol(),MODE_ASK);            
      myBid=MarketInfo(OrderSymbol(),MODE_BID);            
      myTkt=OrderTicket();
      myLot=OrderLots();
      myTyp=OrderType();
            
      switch( myTyp )
        {
         //Close opened long positions
         case OP_BUY      :result = OrderClose(myTkt, myLot, myBid, Slippage, Red);
         break;
      
         //Close opened short positions
         case OP_SELL     :result = OrderClose(myTkt, myLot, myAsk, Slippage, Red);
         break;

         //Close pending orders
         case OP_BUYLIMIT :
         case OP_BUYSTOP  :
         case OP_SELLLIMIT:
         case OP_SELLSTOP :result = OrderDelete( OrderTicket() );
       }
    
      if(result == false)
        {
         Alert("Order " , myTkt , " failed to close. Error:" , GetLastError() );
         Print("Order " , myTkt , " failed to close. Error:" , GetLastError() );
         Sleep(3000);
        }  

      Sleep(1000);

     } //for
  EntryCondition=0; // 0=standingby, 1=buy, 2=sell
  } // closeeverything

//+------------------------------------------------------------------+
//| Dynamic Trailing Stop                                            |
//+------------------------------------------------------------------+
// Check to see if "EnableTrailingStop" is enabled..if not no need to execute
// Only Modify the "StopLevel" here, since the exits are executed on the next function ExitMarket()
// please make sure that the distance is >= 5 pips from the market, otherwise the stop order modification will be rejected.
// Thank you!
int DynamicTrailStop()
{
    //Print("answer call trailstop");
    if(EnableTrailingStop)
      {

       TrailingStop = (TrailingStopFactor * iATR(Symbol(), 0 , TrailATRPeriod , 1) );
       for(int cnt = 0; cnt < OrdersTotal(); cnt++)
         {
            bool DynamicTrailAllowed = true;
            OrderSelect(cnt, SELECT_BY_POS);
            if(OrderMagicNumber() != MagicNumber)//insures only Patient1 placed orders are dynamic trail stop managed
               {
               DynamicTrailAllowed = False;
               }    
            if(DynamicTrailAllowed && OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && TrailingStop > 0)
               {
               if(OrderType() == OP_BUY)// If order is a long position
                  {
                  BuyStop = Bid - TrailingStop;
                  if(BuyStop < PrevBuyStop) // We maintain the highest value
                     {
                     BuyStop = PrevBuyStop;
                     }
                  if(BuyStop > 0 && (Bid - BuyStop) >= Bid - (5 * Point)  && BuyStop > OrderStopLoss())// if new stop loss is allowed and higher than current stop loss
                     {
                     OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0);
                     }
                  }
                  else 
                  {
                  if(OrderType() == OP_SELL)// If order is a short position
                     {
                     SellStop = Ask + TrailingStop;
                     if(SellStop > PrevSellStop) // We maintain the lowest value
                        {
                        SellStop = PrevSellStop;
                        }
                     if(SellStop > 0 && (SellStop - Ask) >= Ask + (5 * Point)  && SellStop < OrderStopLoss())// if new stop loss is allowed and lower than current stop loss
                        {
                        OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0);
                        }
                     }//ifOT=S
                  }//ifOT=B
                           
                  if(OrderType() == OP_BUY)
                  {
                     BuyStop = Bid - TrailingStop;
                     if(BuyStop < PrevBuyStop) BuyStop = PrevBuyStop;
                     if(BuyStop > 0 && (Bid - BuyStop) >= 5 * Point && BuyStop > OrderStopLoss())
                        {
                        OrderModify(OrderTicket(), OrderOpenPrice(), BuyStop, OrderTakeProfit(), 0);
                        }
                  }
                  else 
                  {
                     if(OrderType() == OP_SELL)
                     {
                        SellStop = Ask + TrailingStop;
                        if(SellStop > PrevSellStop) SellStop = PrevSellStop;
                        if(SellStop > 0 && (SellStop - Ask) >= 5 * Point && SellStop < OrderStopLoss())
                           {
                           OrderModify(OrderTicket(), OrderOpenPrice(), SellStop, OrderTakeProfit(), 0);
                           }
                     }
                  }

              }//ifDTA
         PrevBuyStop = BuyStop;
         PrevSellStop = SellStop;
      }//for
   }//ifEnableTS      
return (0);
}//DTS  
double LotSize()
{
    double     lot_min        = MarketInfo( Symbol(), MODE_MINLOT  );
    double     lot_max        = MarketInfo( Symbol(), MODE_MAXLOT  );
    double     lot_step       = MarketInfo( Symbol(), MODE_LOTSTEP );
    double     freemargin     = AccountFreeMargin();
    int        leverage       = AccountLeverage();
    double        lotsize        = MarketInfo( Symbol(), MODE_LOTSIZE );
 
    if( lot_min < 0 || lot_max <= 0.0 || lot_step <= 0.0 || lotsize <= 0 ) 
    {
        Print( "LotSize: invalid MarketInfo() results [", lot_min, ",", lot_max, ",", lot_step, ",", lotsize, "]" );
        return(-1);
    }
    if( leverage <= 0 )
    {
        Print( "LotSize: invalid AccountLeverage() [", leverage, "]" );
        return(-1);
    }
 
    double lot = NormalizeDouble( freemargin * MaximumRisk / leverage / 10.0, 2 );
 
    lot = NormalizeDouble( lot / lot_step, 0 ) * lot_step;
    if ( lot < 0.01 ) lot = 0.01;
    if ( lot > 10 ) lot = 10;
 
    double needmargin = NormalizeDouble( lotsize / leverage * Ask * lot, 2 );
 
    if ( freemargin < needmargin )
    {
        
        Print( "LotSize: We have no money. Need Margin = ", needmargin );
        return(-1);
    }
 
    return(lot);
}